/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 21st, 2004
 Update:  July 4th, 2004
  
***********************************************************************/
#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <string>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Index.h"
#include "Cherry.h"

using namespace std;


double CherryPicking(int n, int m, int i, int j, Taxa * data, int N){
  double mVal = 0;
  mVal = (N - 2); //cout << N - 2 << endl;
  mVal /= (m - 1);//cout << mVal << endl;
  mVal *= newSum2(n, m, i, j, data);
  mVal -= (newSum1(n, m, i, data) + newSum1(n, m, j, data));

  return mVal;
}

void getMatrix(int n, int m, Taxa * data, Table & M){

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++) M.table[i].table[j]= 0;

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++){
      if( i != j)
	M.table[i].table[j] = CherryPicking(n, m, i + 1, j + 1, data, n);
      else M.table[i].table[j] = 1000;
      // cout << i << " " << j << endl;
    }

  cout << "\n\nMatrix M is:" << endl;

  for(int i = 0; i < n; i++){
    for(int j = 0; j < n; j++) cout << M.table[i].table[j] << " ";
    cout << endl;
  }
}

void findMin(int n, int m, int & I, int & J, Taxa * data, Table M){

  double min = 10000;

  getMatrix(n, m,  data, M);

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++){
      if(min > M.table[i].table[j]){ min = M.table[i].table[j];
      I = i + 1;
      J = j + 1;
      } 
    }
}

void getMatrix2(int n, int m, Taxa * data, Table & M, int counter, int* ind, int N){

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++) M.table[i].table[j]= 1000;

    for(int i = 0; i < n; i++)
      for(int j = i + 1; j < n; j++){
	if(i != j) 
	  M.table[i].table[j] = CherryPicking(n, m, i + 1, j + 1, data, N);
	else M.table[i].table[j] = 1000;
      }
    
    for(int k = 0; k <= counter; k++)
      for(int i = 0; i < n; i++)
	if((ind[k] - 1) > 0)
	  {
	    M.table[i].table[ind[k] - 1] = 1000;
	    M.table[ind[k] - 1].table[i] = 1000;
	  }

//     cout << "\n\nMatrix M is:" << endl;
    
//     for(int i = 0; i < n; i++){
//       for(int j = 0; j < n; j++) cout << M.table[i].table[j] << " ";
//       cout << endl;
//     }

}

void findMin2(int n, int m, int & I, int & J, Taxa * data, Table M, int& counter, int* ind, int N){

  double min = 10000;

  getMatrix2(n, m,  data, M, counter, ind, N);

  for(int i = 0; i < n; i++)
    for(int j = i + 1; j < n; j++){
      //      cout << n - i << " " << n - j << endl;
      if(min > M.table[i].table[j])
	{ min = M.table[i].table[j];
	I = i + 1;
	J = j + 1;
	} 
    }
  counter++;
  ind[counter] = J;
}

void Subsets3(int N, int M, int I, int K, int *array, ofstream & out)
{
  
    if((M-K) == (N-I+1))
         return;
 
    if((M-K) == 0)
    {
        for(int i = 0; i < N; i++)
             if(array[i] == 1)
                 out << i << "  ";
 
         out << endl;
         return;
     }
 
 
        
    int newArray[N];
    for(int i = 0; i < N; i++) newArray[i] = 0;
 
    //copy the K precomputed values from array[]
 
    for(int i = 0; i < I; i++)
        newArray[i] = array[i];
 
 
     //compute all subsets where we choose element I
     newArray[I] = 1;
     Subsets3(N, M, I+1, K+1, newArray, out);
 
     //compute all subsets where we DON'T choose element I
     newArray[I] = 0;
     Subsets3(N, M, I+1, K, newArray, out);
 
    return;
    
 
}
 
 
int getList3(int N, int M){

  int array[N];

  for(int i = 0; i < N; i++) array[i] = 0;
  //Print out all subsets of size M
 
  ofstream out;
  out.open("ListOfSubsets");

  Subsets3(N, M, 0, 0, array, out);

  return 0;
}

void testTaxa(int n, int m, Taxa * data){
  int numOfrows = Choose(n, m), j = 0;
  double sum = 0;
  for(j = 0; j < numOfrows; j++) {
    for(int i = 0; i < m; i++) cout << data[j].array[i] << " ";
    cout << ": " << data[j].wt << endl;
    sum += data[j].wt;
  }
  cout << sum << endl;

}
 
void UpdateTaxa(int n, int m, int I, int J, Taxa * data){
  int numOfrows = Choose(n - 1, m - 1), j = 0, k = 0, tmp;
  int index[numOfrows][m], index2[numOfrows][m];

   /* Test */
//   int index3[2];
//   index3[0] = I;
//   index3[1] = J;
//   bubblesort(2, index3);
//   double tmp2 = -(data[getIndexNumber(n, 2, index3) - 1].wt/2);
  /* up to here */

  getList3(n - 1, m - 1);

  ifstream in;
  in.open("ListOfSubsets");
  
  for(j = 0; j < numOfrows; j++){
    for(k = 0; k < (m - 1); k++){
      tmp = 0;
      in >> tmp;
      tmp++;
 
      if(tmp == I)
	index[j][k] = n; 
      else index[j][k] = tmp; 
    }
    
    index[j][m - 1] = I;

    for(k = 0; k < m; k++){
      if(index[j][k] == I) index2[j][k] = J;
      else if(index[j][k] == J) index2[j][k] = I;
      else index2[j][k] = index[j][k];
    }

    bubblesort(m, index[j]);
    bubblesort(m, index2[j]);

    /* Testing... */
//     int sum1 = 0;
//     for(int s = 0; s < m; s++)
//       for(k = 0; k < m; k++){
// 	int flag = 0;
// 	if(index[j][k] == J) flag = 1;
// 	if(index[j][k] == index2[j][s])
// 	  if(index[j][k] != I) 
// 	    if(index[j][k] != J) sum1++;
// 	if(flag == 1) sum1++;
//       }

//     //cout << sum1 << endl;
//     if(sum1 < (m - 1)) {
//       cout << I << " " << J << endl;
//       for(int s = 0; s < m; s++)
// 	cout << index[j][s] << " ";
//       cout << endl;
//       for(int s = 0; s < m; s++)
// 	cout << index2[j][s] << " ";
//       cout << endl << endl;
//       cout << sum1 << endl;
//       exit(0);}
    
//     cout << I << " " << J << endl;
//     for(int s = 0; s < m; s++)
//       cout << index[j][s] << " ";
//     cout << endl;
//     for(int s = 0; s < m; s++)
//       cout << index2[j][s] << " ";
//     cout << endl << endl;
    
     /* Upto here... */

    data[getIndexNumber(n, m, index[j]) - 1].wt = (data[getIndexNumber(n, m, index[j]) - 1].wt + data[getIndexNumber(n, m, index2[j]) - 1].wt)/2;

    /* Test */
//     if(data[getIndexNumber(n, m, index[j]) - 1].wt != 0) data[getIndexNumber(n, m, index[j]) - 1].wt += tmp2;
    /* Upto here... */

    data[getIndexNumber(n, m, index2[j]) - 1].wt = 0;
    
  } 
  
  system("rm ListOfSubsets");

}


void setZero(int n, int m, int I, Taxa * data){
  int numOfrows = Choose(n - 1, m - 1), j = 0, k = 0, tmp;
  int index[numOfrows][m];
 
  getList3(n - 1, m - 1);

  ifstream in;
  in.open("ListOfSubsets");
  
  for(j = 0; j < numOfrows; j++){
    for(k = 0; k < (m - 1); k++){
      tmp = 0;
      in >> tmp;
      tmp++;
 
      if(tmp == I)
	index[j][k] = n; 
      else index[j][k] = tmp; 
    }
    
    index[j][m - 1] = I;

    bubblesort(m, index[j]);

    for(int s = 0; s < m; s++) 
      if(data[getIndexNumber(n, m, index[j]) - 1].array[s] != index[j][s])
	{for(int ss = 0; ss < m; ss++) cerr << index[j][ss] << " "; cerr<<endl; 
	for(int ss = 0; ss < m; ss++)  cerr<< data[getIndexNumber(n, m, index[j]) - 1].array[ss] << " ";  exit(1);
	}
    

    data[getIndexNumber(n, m, index[j]) - 1].wt = 0;
    
  } 
  
  system("rm ListOfSubsets");

}

/*******************************************************************/

void UpdateTaxa2(int n, int m, int I, int J, Taxa * data){
  int numOfrows = Choose(n - 1, m - 1), j = 0, k = 0, tmp[m];
  int index[numOfrows][m], index2[numOfrows][m];
  double TwoWts[n][n];

  getList3(n - 1, m - 1);

  ifstream in2("2-weights.tax");
  if(!in2){
    cerr << "Reading error on 2-weights.tax." << endl;
    exit(0);
  }

  for(int i = 0; i < n; i++)
    for(j = i + 1; j < n; j++)
     { in2 >> TwoWts[i][j];
     TwoWts[j][i] = TwoWts[i][j];
     }
  
//   for(int i = 0; i < n; i++){
//     for(j = 0; j < n; j++)
//        cout << TwoWts[i][j] << " ";
//     cout << endl;
//   }

  ifstream in;
  in.open("ListOfSubsets");
  
  for(j = 0; j < numOfrows; j++){
    for(k = 0; k < (m - 1); k++){
      tmp[k] = 0;
      in >> tmp[k];
      tmp[k]++;
      if(tmp[k] == I)
	index[j][k] = n;
      else index[j][k] = tmp[k];
    }    
    
    index[j][m - 1] = I;
    
    for(k = 0; k < m; k++){
      if(index[j][k] == I) index2[j][k] = J;
      else if(index[j][k] == J) index2[j][k] = I;
      else index2[j][k] = index[j][k];
    }

    bubblesort(m, index[j]);
    bubblesort(m, index2[j]);
    
//     for(int s = 0; s < m; s++)
//       cout << index[j][s] << " ";
//     cout << endl;
//     for(int s = 0; s < m; s++)
//       cout << index2[j][s] << " ";
//     cout << endl << endl;
    
    data[getIndexNumber(n, m, index[j]) - 1].wt = (data[getIndexNumber(n, m, index[j]) - 1].wt + data[getIndexNumber(n, m, index2[j]) - 1].wt - TwoWts[I - 1][J - 1])/2;
    data[getIndexNumber(n, m, index2[j]) - 1].wt = 0;
    
  } 
  
  system("rm ListOfSubsets");

}

/*********** Original NJ method only ********************************/

double CherryPicking_Original(int n, int i, int j, Taxa * data, int N){
  double mVal = 0;
  mVal = (N - 2); //cout << N - 2 << endl;
  mVal *= Sum2_Original(n, i, j, data);
  mVal -= (Sum1_Original(n, i, data) + Sum1_Original(n, j, data));

  return mVal;
}

void getMatrix_Original(int n, Taxa * data, Table & M){

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++) M.table[i].table[j]= 10000;
  
  for(int i = 0; i < n; i++)
    for(int j = i + 1; j < n; j++){
      M.table[i].table[j] = CherryPicking_Original(n, i + 1, j + 1, data, n);
      
      // cout << i << " " << j << endl;
    }
}


void findMin_Original(int n, int & I, int & J, Taxa * data, Table M){

  double min = 10000;

  getMatrix_Original(n, data, M);

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++){
      if(min > M.table[i].table[j]){ min = M.table[i].table[j];
      I = i + 1;
      J = j + 1;
      } 
    }
}

void getMatrix2_Original(int n, Taxa * data, Table & M, int counter, int* ind, int N){

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++) M.table[i].table[j]= 1000;

    for(int i = 0; i < n; i++)
      for(int j = i + 1; j < n; j++){
	if(i != j) 
	  M.table[i].table[j] = CherryPicking_Original(n, i + 1, j + 1, data, N);
	else M.table[i].table[j] = 1000;
      }
    
    for(int k = 0; k <= counter; k++)
      for(int i = 0; i < n; i++)
	if((ind[k] - 1) > 0)
	  {
	    M.table[i].table[ind[k] - 1] = 1000;
	    M.table[ind[k] - 1].table[i] = 1000;
	  }

//     cout << "\n\nMatrix M is:" << endl;
    
//     for(int i = 0; i < n; i++){
//       for(int j = 0; j < n; j++) cout << M.table[i].table[j] << " ";
//       cout << endl;
//     }

}

void findMin2_Original(int n, int & I, int & J, Taxa * data, Table M, int& counter, int* ind, int N){

  double min = 10000;

  getMatrix2_Original(n, data, M, counter, ind, N);

  for(int i = 0; i < n; i++)
    for(int j = i + 1; j < n; j++){
      //      cout << n - i << " " << n - j << endl;
      if(min > M.table[i].table[j])
	{ min = M.table[i].table[j];
	I = i + 1;
	J = j + 1;
	} 
    }
  counter++;
  ind[counter] = J;
}
 
void UpdateTaxa_Original(int n, int I, int J, Taxa * data){
  int numOfrows = n - 1, j = 0, k = 0;
  int index[numOfrows][2], index2[numOfrows][2];
  int index3[2];
  index3[0] = I;
  index3[1] = J;
  bubblesort(2, index3);
  double tmp = -(data[getIndexNumber(n, 2, index3) - 1].wt/2.0);
 
  for(j = 0; j < numOfrows; j++){
    if((j + 1) == I)
      index[j][0] = n;
    else index[j][0] = j + 1;
      index[j][1] = I;

    for(k = 0; k < 2; k++){
      if(index[j][k] == I) index2[j][k] = J;
      else if(index[j][k] == J) index2[j][k] = I;
      else index2[j][k] = index[j][k];
    }

    bubblesort(2, index[j]);
    bubblesort(2, index2[j]);

    data[getIndexNumber(n, 2, index[j]) - 1].wt = (data[getIndexNumber(n, 2, index[j]) - 1].wt + data[getIndexNumber(n, 2, index2[j]) - 1].wt)/2;
    
    if(data[getIndexNumber(n, 2, index[j]) - 1].wt > 0)
      data[getIndexNumber(n, 2, index[j]) - 1].wt += tmp;
    
    data[getIndexNumber(n, 2, index2[j]) - 1].wt = 0;
  }
  
  
}


/*************************** Test ********************************/

void newPreUpdate2(int N, int M, int I, int K, int *array, double & sum, Taxa * data, int ii, int J)
{
  int n = N + 1, m = M + 1;  
  int index[m], index2[m], k = 0, tmp;
  
  //If we have already excluded too many items, then return
  
  if((M-K) == (N-I+1))
    return;
  
  
  //if we have finished comuting a subset, then print it out
  
  if((M-K) == 0)
    {
      for(int i = 0; i < N; i++)
	if(array[i] == 1)
	  {  // cout << i << "  ";
	    tmp = i + 1;
	    
	    if(tmp == ii)
	      index[k] = n; 
	    else index[k] = tmp;
	    k++; 
	  }
    
    index[m - 1] = ii;

    for(k = 0; k < m; k++){
      if(index[k] == ii) index2[k] = J;
      else if(index[k] == J) index2[k] = ii;
      else index2[k] = index[k];
    }
    
    bubblesort(m, index);
    bubblesort(m, index2);
    
    
    data[getIndexNumber(n, m, index) - 1].wt = (data[getIndexNumber(n, m, index) - 1].wt + data[getIndexNumber(n, m, index2) - 1].wt)/2;
 
    data[getIndexNumber(n, m, index2) - 1].wt = 0;
    
    return;
    }
  
 
        
  int newArray[N];
  for(int i = 0; i < N; i++) newArray[i] = 0;
  
  //copy the K precomputed values from array[]
  
  for(int i = 0; i < I; i++)
    newArray[i] = array[i];
 
  
  //compute all subsets where we choose element I
  newArray[I] = 1;
  newPreUpdate2(N, M, I+1, K+1, newArray, sum, data, ii, J);
  
  //compute all subsets where we DON'T choose element I
  newArray[I] = 0;
  newPreUpdate2(N, M, I+1, K, newArray, sum, data, ii, J);
  
  return;
  
}
 
 
double newUpdateTaxa(int N, int M, int I, int J, Taxa * data){
  int array[N - 1];
  double sum = 0;

  for(int k = 0; k < (N - 1); k++) array[k] = 0;
  //Print out all subsets of size M
 
  newPreUpdate2(N - 1, M - 1, 0, 0, array, sum, data, I, J);
 
  return sum;
}
 
