#include "TreeNode.h"
#include "Newick.h"
#include <lapack++.h>
#include <lapack.h>
#include <lafnames.h>
#include <iostream>
#include "Felsenstein.h"
#include "Mjoin.h"
#include "Seq.h"
#include "Timer.h"
#include "NJTree.h"
#include "JC-Tree.h"
#include "cmpressed.h"


using namespace std;



int main(int argc, char **argv)
{
  Alinements * InputData;
  int n = 0, **Mat, length, **cmpMatrix, newLn;
  char filename[127], newick[127];
  cout.precision(4);
  cout.setf(ios::scientific, ios::floatfield);
  int numSt = 4, numNds = 4, numLvs = 5, num = 0;
  int Obs[numLvs], **PhlMat;
  LaVectorDouble BrLenV(numLvs + numNds - 1);
  double logL = 0.0;
  int ** iniTreeMatrix, **subTreeMat;
  LaSymmMatDouble RateMat, Q(numSt, numSt);
  LaGenMatDouble CndProbMat(numNds + numLvs - 1, numSt * numSt);
  TreeNode* tree;
  char** listOfNames;
  LaVectorDouble FreqVec(numSt), Tht(Choose(numSt, 2));
 
  char *freq, *TsTv;
  freq = new char[127];
  TsTv = new char[127];
  strcpy(freq, "yes");
  strcpy(TsTv, "yes");

  if(argc < 2){
    cerr << "Please enter the input file name." << endl;
    exit(0);
  }

  strcpy(filename, argv[1]);

//   ReadFMA(n, filename, &InputData);

//   removeDash(&InputData, n);
//   length = InputData[0].DNA.length();
//   Mat = DNAMat(InputData, n, length);
//   cout << length << endl;
//   cmpMatrix = cmpressed(Mat, n, newLn, length);

  FreqVec(0) = 0.2; FreqVec(1) = 0.3;  FreqVec(2) = 0.4;  FreqVec(3) = 0.1;

  Tht(0) = 8;  Tht(1) = 1; Tht(2) = 2;  Tht(3) = 1;  Tht(4) = 1; Tht(5) = 8;

//   for(int i = 0; i < (n + 1); i++){
//     for(int j = 0; j < newLn; j++)
//       cout << cmpMatrix[i][j] << " ";
//     cout << endl;
//   }

/* Constructing Tree matrix and initializing tree. */
  PhlMat = writeTreeMatrix(filename, newick, numLvs, BrLenV, &InputData);
//   tree = new TreeNode;
//   tree = copy(MJOIN(n, 2, filename, freq, TsTv, FreqVec(0), FreqVec(1), FreqVec(2), FreqVec(3), 0.5, &InputData), tree);
//   cleanNum(tree, num);
  int dim = 2 * n - 1, h = 0;
//   BrLenV.resize(dim - 1, 1); 
//   for(int i = 0; i < (dim - 1); i++) BrLenV(i) = 0.0; 
//   PhlMat = new int*[dim];
//   for(int i = 0; i < dim; i++) 
//     PhlMat[i] = new int[4];
//   printDND3(tree);
//   assignLeafLevel(tree, h);
//   assignNum(tree, h, n);
//   TreeMatrix(PhlMat, tree, dim, BrLenV);
/* end of Constructing Tree matrix and initializing tree. */

//   PhlMat = writeTreeMatrix(filename, newick, numLvs, BrLenV, &InputData,
// 			   FreqVec(0), FreqVec(1), FreqVec(2), FreqVec(3), 
//   			   freq, TsTv);
  cout << FreqVec(0) << " " << FreqVec(1) << " " << FreqVec(2) << " " << FreqVec(3) << endl;

  length = InputData[0].DNA.length();
  Mat = DNAMat(InputData, n, length);
  cout << length << endl;
  cmpMatrix = cmpressed(Mat, n, newLn, length);

  for(int i = 0; i < (n + 1); i++){
    for(int j = 0; j < newLn; j++)
      cout << cmpMatrix[i][j] << " ";
    cout << endl;
  }

  for(int i = 0; i < dim; i++){ 
      for(int j = 0; j < 4; j++)
	cout << PhlMat[i][j] << " "; 
      cout << endl;
  }

  RateMat = GTRRateMFct(FreqVec, Tht, numSt);
  cout << RateMat << endl;

  return 0;
}

// int main(int argc, char **argv){
//   /* Precision for printing.... */
//   cout.precision(4);
//   cout.setf(ios::scientific, ios::floatfield);

//   /* Declearing variables.... */
//   int numSt = 4, numNds = 4, numLvs = 5, ** PhylMat, **SeqMat, nIter = 0;
//   int Obs[numLvs], SeqLen = 0;
//   LaVectorDouble BrLenV(numLvs + numNds - 1), BrLenV2;
//   double logL = 0.0;
//   LaSymmMatDouble RateMat(numSt, numSt), Q(numSt, numSt);
//   LaGenMatDouble CndProbMat(numNds + numLvs - 1, numSt * numSt);
//   char invocation[200], filename[127], Newick[127];
//   Alinements * InputData;
//   LaVectorDouble FreqVec(numSt);
  
//   /* Reading input files and arguements.... */
//   if(argc < 3){
//     cerr << "Please enter an input file name!" << endl;
//     exit(0);
//   }
//   strcpy(filename, argv[argc-1]);
//   strcpy(Newick, "no");
  
// //   strcpy(invocation, "invocation: ");
// //   for(int f = 0; f < argc; f++){
// //     strcat(invocation, argv[f]);
// //     strcat(invocation, " ");
// //     if(strncmp(argv[f], "-r", 2) == 0)    strcpy(Newick, "yes");
// //   }
  
//   nIter = atoi(argv[1]);
  
//   /* Setting the JC model..... */
//   for(int i = 0; i < numSt; i++) FreqVec(i) = 0.25;
  
//   for(int i = 0; i < numSt; i++)
//     for(int j = 0; j < numSt; j++){
//       RateMat(i, j) = ((double)1)/((double)3);
//       Q(i, j) = ((double)1)/((double)6);
//     }
//   for(int i = 0; i < numSt; i++) {RateMat(i, i) = -1.0; Q(i, i) = -0.5;}
  
//   /* Initializing variables...... */  
//   PhylMat = new int*[numLvs + numNds];
//   for(int i = 0; i < (numLvs + numNds); i++)
//     PhylMat[i] = new int[4];
//   for(int i = 0; i < (numLvs + numNds); i++)
//     for(int j = 0; j < 4; j++) 
//       PhylMat[i][j] = 0;
  
//   numLvs = 0;
  
//   /* Writing tree matrix from DNA sequences using MJOIN to get initial Branchlengths..... */
//   PhylMat = writeTreeMatrix(filename, Newick, numLvs, BrLenV2, &InputData);
//   //cout << InputData[0].DNA.length() << endl;
//   numNds = numLvs - 1; 
//   int dim = (2 * numLvs) - 1; 
// //   cout << dim << endl;
// //     for(int i = 0; i < dim; i++){
// //       for(int j = 0; j < 4; j++)
// //         cout << PhylMat[i][j] << " ";
// //       cout << endl;
// //   }
  
//   /* Converting letters to numbers.... */
//   SeqMat = DNAMat(InputData, numLvs, SeqLen);
//   //cout.precision(16);
//   //cout << fixed << BrLenV2 << endl;
//   JC_tree(SeqMat, PhylMat, RateMat, FreqVec, BrLenV2, numSt, numLvs, 
// 	  numNds, nIter, SeqLen);
//   return 0;
// }

