/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 21st, 2004
 Update:  November 11th, 2004
  
***********************************************************************/

#include <iostream.h>
#include <fstream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "TreeNode.h"
#include "Cherry.h"
#include "NJTree.h"
#include "Index.h"
#include "TreeTable.h"

using namespace std;

double inf = 10000000;

void DFS2(TreeNode* node){
  if(node != 0){
    cout.precision(8);
    if(node -> wt != -10000){
      if(node -> name == -1)
	{
	  cout << "(";
	  DFS2(node -> left);
	  cout << ",";
	  DFS2(node -> right);
	    cout << ")";
	    cout << ":";
	    cout << fixed << node -> wt;
	}      
      else {
	cout << node -> RealName;
	cout << ":";
	cout << fixed << node -> wt;
      }
    }
    else {
      cout << "(";
      DFS2(node -> left);
      cout << ",";
      DFS2(node -> right);
      cout << ");" << endl;
    }
  }
}

void printDND(TreeNode* node, ofstream & out){
  if(node != 0){
    out.precision(8);
    if(node -> wt != -10000){
      if(node -> name == -1)
	{
	  out << "(";
	  printDND(node -> left, out);
	  out << ",";
	  printDND(node -> right, out);
	    out << ")";
	    out << ":";
	    out << fixed << node -> wt;
	}      
      else {
	//out << node -> name;
	out << node -> RealName;
	out << ":";
	out << fixed << node -> wt;
      }
    }
    else {
      out << "(";
      printDND(node -> left, out);
      out << ",";
      printDND(node -> right, out);
      out << ");" << endl;
    }
  }
}

/* These functions are for computing edge wts... */


void helpSearch(TreeNode * root, int index, TreeNode** leaf){
  if(!root) ;
  else{
    if(root -> name != index)
      { 
	helpSearch(root -> left, index, leaf);
	helpSearch(root -> right, index, leaf);
      }
    else (*leaf) = root; 
  }
}

void deleteTree(TreeNode* tree){
   if( tree != NULL )
   {
     deleteTree( tree -> left );
     deleteTree( tree -> right );
     delete tree;
     tree = NULL;
   }
}

void totalWt(TreeNode* tree, double & wt){
   if( tree != NULL )
   {
     if(tree -> wt != -10000)
       wt += tree -> wt;
     totalWt( tree -> left, wt );
     totalWt( tree -> right, wt );
   }
}

void searchNode(TreeNode * root, int index, TreeNode** leaf){
  helpSearch(root, index, leaf);
}


void helpSearch2(TreeNode * root, int index, TreeNode** leaf){
  if(!root) ;
  else{
    if(root -> num != index)
      { 
	helpSearch2(root -> left, index, leaf);
	helpSearch2(root -> right, index, leaf);
      }
    else (*leaf) = root; 
  }
}


void searchNode2(TreeNode * root, int index, TreeNode** leaf){
  helpSearch2(root, index, leaf);
}

void printTree(TreeNode* node, int number){
  if(node != 0){
    //      node -> printNode();
    printTree(node -> right, number + 7);
    for(int i = 0; i < number; i++) cout << " ";
    node -> printNode();
    printTree(node -> left, number + 7);
  }
}


TreeNode* clone( TreeNode* node, TreeNode * parent)
{
   if(!node) return 0;
   else{
     TreeNode* cp = new TreeNode;
     if(node -> name != -1)
       cp -> Allocate(node -> RealName);
     cp -> name = node -> name;
     cp -> wt = node -> wt;
     cp -> hight = node -> hight;
     cp -> parent = parent;
     cp -> flag = node -> flag;
     cp -> left = clone(node -> left, cp);
     cp -> right = clone(node -> right, cp);
     return cp;
   }
}

void assignNum1(TreeNode* node, int & num){
  if(node != NULL){
    node -> num = num;
    num++;
    assignNum1(node -> left, num);
    assignNum1(node -> right, num);
  }
}

void assignNum(TreeNode* node){
  int num = 0; 
  assignNum1(node, num);
}

void cleanNum1(TreeNode* node){
  if(node != NULL){
    node -> num = 0;
    node -> hight = 1;
    node -> flag = 0;
    cleanNum1(node -> left);
    cleanNum1(node -> right);
  }
}

void helpL(TreeNode* node, int num, int & counter){
  if(node != NULL){
    helpL(node -> left, num, counter);
    helpL(node -> right, num, counter);
    if(node -> name != -1) {counter++; }
  }
}

void helpL2(TreeNode* node, int & flag, int name){
  if(node != NULL){
    helpL2(node -> left, flag, name);
    helpL2(node -> right, flag, name);
    if(node -> name == name) flag = 1;
  }
}

void L(TreeNode* node, int num, int name, int n, int & counter, double & wt){
  int flag = 0;
  TreeNode* leaf, *tree;
  tree = clone(node, tree);
  assignNum(tree);
  //printTree(tree, 0);
  searchNode2(tree, num, &leaf);  
  wt = leaf -> wt;
  // printTree(leaf, 0);
  helpL(leaf, num, counter);
  helpL2(leaf, flag, name);
  if(flag == 0) counter = n - counter;
  if(leaf -> name != -1) wt = 0;
  deleteTree(tree);
}

void valueC(TreeNode * node, int name, int n, int m, double & sum){
  int i, flag = 0, counter = 0, right = 0, left = 0;
  double wt = 0;
  sum = 0.0;
  if((node -> left -> name != -1) || (node -> right -> name != -1)){
    flag = 1;
    if(node -> left -> name != -1) left = 1;
    else right = 1;
  }

  if(flag == 0){  
    for(i = 0; i < (2 * n - 2); i++) 
      { counter = 0; wt = 0;
      L(node, i + 1, name, n, counter, wt); 
      sum += (double) (Choose((n - 2), (m - 2)) - Choose((counter - 2), (m - 2))) * wt; 
      }
  }
  else{
    if(left == 1)
      for(i = 0; i < (2 * n - 4); i++) 
	{ counter = 0; wt = 0; 
	L(node -> right, i + 1, name, n, counter, wt); 
	sum += (double) (Choose((n - 2), (m - 2)) - Choose((counter - 2), (m - 2))) * wt; 
	}
    else 
      for(i = 0; i < (2 * n - 4); i++) 
	{ counter = 0; wt = 0;
	L(node -> left, i + 1, name, n, counter, wt); 
	sum += (double) (Choose((n - 2), (m - 2)) - Choose((counter - 2), (m - 2))) * wt;
	}
  }
}

void computingEdgeWts(TreeNode * node, int n, int m, double * Wts){
  double sum[n], x, y;
  double a = 0, b = 0, A[n][n], I[n][n], J[n][n], wts[n];
  //  cout << "\nComputing leaf weights....";
  a = 2 * ((double) Choose((n - 3), (m - 2)));
  b = ((double) Choose((n - 3), (m - 3)));

  x = 1 / a;
  y = -b /(a * (a + n * b));
 
  for(int i = 0; i < n; i++){
    for(int j = 0; j < n; j++){
      if(i != j) I[i][j] = 0.0;
      else I[i][j] = 1.0; 
      J[i][j] = 1.0; 
    }
    wts[i] = Wts[i];
  }
 

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++){
      A[i][j] = (x * I[i][j]) + (y * J[i][j]);
    }

//   for(int i = 0; i < n; i++){
//     for(int j = 0; j < n; j++) cout << A[i][j] << " ";
//     cout << endl;
//   }

  for(int i = 0; i < n; i++)
    {
      sum[i] = 0.0;
      valueC(node, i + 1, n, m, sum[i]);
    }

  for(int i = 0; i < n; i++){ 
    Wts[i] = 0.0;
    for(int j = 0; j < n; j++) Wts[i] += (2 * wts[j] - sum[j]) * A[i][j];
  } 
  //  cout << "done." << endl;
}

void adjustInteriorEdgeWts(int n, int m, TreeNode* node1){
  double wt1 = 0;
 
  if(node1 -> name == -1) {
    wt1 = (double) (Choose((node1 -> hight - 2), (m - 2)) + Choose(((n - node1 -> hight) - 2), (m - 2)));
    node1 -> wt *= 2;
    node1 -> wt /= wt1; 
  } 
}

void treeAdjustInteriorEdgeWts(int n, int m, TreeNode* node1){
  if(node1 != NULL){
    if(node1 -> wt != -10000)
      adjustInteriorEdgeWts(n, m, node1);
    treeAdjustInteriorEdgeWts(n, m, node1 -> right);
    treeAdjustInteriorEdgeWts(n, m, node1 -> left);
  }
}

void adjustLeafEdgeWts(TreeNode * tree, double * Wts){
  if(tree != NULL){
    if(tree -> name != -1)
      tree -> wt = Wts[tree -> name - 1];
    adjustLeafEdgeWts(tree -> left, Wts);
    adjustLeafEdgeWts(tree -> right, Wts);
  }
}

/* Upto here... */

TreeNode* getRoot(TreeNode* node){

  if(node != 0){
    if(node -> parent == 0) ;
    else getRoot(node -> parent);
  }

  return node;
}

void CreateTreeMatric(Taxa * Data, int n, int m, Taxa * S){
  int i, j, counter = 0;
  for(i = 0; i < n; i++)
    for(j = i + 1; j < n; j++){
      S[counter].array[0] = i + 1;
      S[counter].array[1] = j + 1;
      S[counter].wt = newSum2(n, m, i + 1, j + 1, Data);
      counter++;
    }
}

void testNJ(int n, Taxa * S, char** names){
  int i, j, index[2];
  unsigned int max = 10;

  ofstream out;
  out.open("infile");
  out << n << endl;
  for(i = 1; i <= n; i++){
    if(max > strlen(names[i - 1])){
      out << names[i - 1];
      for(unsigned int k = (strlen(names[i - 1])); k < max; k++) out << " ";
    }
    else {
      for(unsigned int k = 0; k < (max - 1); k++) out << names[i - 1][k];
      out << " ";
    }
    for(j = 1; j <= i; j++){
      if(j == i) out << 0 << " ";
      else{
	index[0] = i;
	index[1] = j;
	bubblesort(2, index);
	//	cout << index[0] << " " << index[1] << endl;
	out << S[getIndexNumber(n, 2, index) - 1].wt << " ";
      }
    }
    out << endl;
  }
  // exit(0);
  system("./neighbor < in > out.jnk");
  system("rm out.jnk");
}

void CreateTree(Taxa * Data, int n, int m, int numOfWeights, char** names)
{
  int N = n, i, counter = 0, cherry1, cherry2, ind[n], index[n];

  TreeNode * leaves[n], *root;
  Table M(n);

  root = new TreeNode;

  for(i = 0; i < n; i++) 
    {  

      leaves[i] = new TreeNode;
      leaves[i] -> name = i + 1;
      leaves[i] -> Allocate(names[i]);

      /* for now, edge weight is 0... */
      leaves[i] -> wt = 0;

      // cout << names[i] << endl;
      ind[i] = 0;
      index[i] = i + 1;
    }

  //  PhylTree Btree(root);
  
  while(N > (m + 1)){
    cout << endl << N << endl;
    TreeNode * tmpNode, *newNode;

    findMin2(n, m, cherry1, cherry2, Data, M, counter, ind, N);

    newNode = new TreeNode;
 
    newNode -> left = leaves[cherry1 - 1];
    newNode -> right = leaves[cherry2 - 1];
    leaves[cherry1 - 1] -> parent = newNode;
    leaves[cherry2 - 1] -> parent = newNode;

    /* for now, edge weight is 0... */
    newNode -> wt = 0;

     tmpNode = newNode;
     leaves[cherry1 - 1] = tmpNode;

     //cout << endl << "\nCherry: " << names[cherry1 - 1] << " " << names[cherry2 - 1] << endl;
     //   cout << endl << cherry1 << " " << cherry2 << endl;

    DFS2(newNode);
    cout << endl << endl;
  
    
//     cout << cherry1 << " " << cherry2 << endl;
//     for(i = 0; i < n; i++)
//       cout << ind[i] << " ";
//     cout << endl;

    //setZero(n, m, cherry2, Data);

    newUpdateTaxa(n, m, cherry1, cherry2, Data);
    //   if(N == (m + 3))    testTaxa(n, m, Data);

    N--;
  }


  // testTaxa(n, m, Data);

  cout << "\nTemporary forests are: " << endl;
  for(i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      if(index[i] == ind[j]) index[i] = 0;
    if(index[i] != 0){
      cout << endl;
      DFS2(leaves[index[i] - 1]);
      cout << endl;
    }
  }
//   for(i = 0; i < n; i++)
//     if((index[i] - 1)> -1)
//       cout << index[i] << " ";
//   cout << endl;


  cout << endl; 
}

void EdgeWts(Taxa * Data, int n, int m, int i, int j, double & wts1, double & wts2, int N){
  double tmp = 0;
  wts1 = newSum2(n,m, i, j, Data)/2;
  tmp = ((newSum1(n,m, i, Data)) - newSum1(n, m, j, Data));
  tmp = tmp/2;
  tmp /= (N - 2);
  wts1 += tmp;
  wts2 = newSum2(n, m, i, j, Data) - wts1;
}


void CreateTree2(Taxa * Data, int n, int m, int mm, int numOfWeights, char** names)
{
  int N = n, i, counter = 0, cherry1, cherry2, ind[n], index[n];

  TreeNode * leaves[n], *root, *root1, *root2, *tree;
  Table M(n);

  double leafWts[n];

  root = new TreeNode;

  for(i = 0; i < n; i++) 
    {  

      leaves[i] = new TreeNode;
      leaves[i] -> name = i + 1;
      leaves[i] -> Allocate(names[i]);

      /* for now, edge weight is 0... */
      leaves[i] -> wt = 0;

      ind[i] = 0;
      index[i] = i + 1;
    }


  while(N > m){
    //    cout << endl << N << endl;
    TreeNode * tmpNode, *newNode;

    findMin2_Original(n, cherry1, cherry2, Data, M, counter, ind, N);
    //  cout << cherry1 << " " << cherry2 << endl;
    newNode = new TreeNode;
 
    newNode -> left = leaves[cherry1 - 1];
    newNode -> right = leaves[cherry2 - 1];
    leaves[cherry1 - 1] -> parent = newNode;
    leaves[cherry2 - 1] -> parent = newNode;
    EdgeWts(Data, n, m, cherry1, cherry2, leaves[cherry1 - 1] -> wt, leaves[cherry2 - 1] -> wt, N);

    if(leaves[cherry1 - 1] -> name != -1) leafWts[leaves[cherry1 - 1] -> name - 1] = leaves[cherry1 - 1] -> wt;
    if(leaves[cherry2 - 1] -> name != -1) leafWts[leaves[cherry2 - 1] -> name - 1] = leaves[cherry2 - 1] -> wt;

    if(mm > 2){
      adjustInteriorEdgeWts(n, mm, leaves[cherry1 - 1]);
      adjustInteriorEdgeWts(n, mm, leaves[cherry2 - 1]);
    }

    /* for now, edge weight is 0... */
    newNode -> wt = 0;
    newNode -> hight = leaves[cherry1 - 1] -> hight + leaves[cherry2 - 1] -> hight; 
     tmpNode = newNode;
     leaves[cherry1 - 1] = tmpNode;

//     DFS2(newNode);
//     cout << endl << endl;

    UpdateTaxa_Original(n, cherry1, cherry2, Data);

    N--;
  }

  int kk = 0, index3[2];
  for(i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      if(index[i] == ind[j]) index[i] = 0;
    //if(index[i] != 0) cout << index[i] << " ";
   if(index[i] != 0){ index3[kk] = index[i];  kk++;}
  }

//   int Flag = 0;
//   for(i = 0; i < 2; i++)
//     if(leaves[index3[i] - 1] -> name != -1) Flag = 1;
  
//   for(i = 0; i < 2; i++){ 
//     leaves[index3[i] - 1] -> wt = newSum2(n,m, index3[0], index3[1], Data)/2;
//     if((mm > 2) && (Flag == 0))
//       adjustInteriorEdgeWts(n, mm, leaves[index3[i] - 1]);
//   }

  int Flag[2], Flag2 = 0;
  Flag[0] = 0, Flag[1] = 0;
  for(i = 0; i < 2; i++)
    if(leaves[index3[i] - 1] -> name != -1){ Flag[i] = 1; Flag2 = 1;}
  
  for(i = 0; i < 2; i++){ 
    if(Flag2 == 1){
      if(Flag[i] == 1)
	leaves[index3[i] - 1] -> wt = newSum2(n,m, index3[0], index3[1], Data);
      leafWts[leaves[index3[i] - 1] -> name - 1] = leaves[index3[i] - 1] -> wt;
    }
  }

  if(Flag2 == 0)    
    leaves[index3[0] - 1] -> wt = newSum2(n,m, index3[0], index3[1], Data);
  if((mm > 2) && (Flag2 == 0)){
    adjustInteriorEdgeWts(n, mm, leaves[index3[0] - 1]);
  }

  root = new TreeNode;
  root1 = clone(leaves[index3[0] - 1], root);
  root2 = clone(leaves[index3[1] - 1], root);
  deleteTree(leaves[index3[0] - 1]);
  deleteTree(leaves[index3[1] - 1]);

  root -> left = root1;
  root -> right = root2;

  // DFS2(root);
  assignNum(root);
 
  tree = clone(root,tree);
  assignNum(tree);
  // printTree(tree, 0);
  if(mm > 2){
    computingEdgeWts(tree, n, mm, leafWts);
    adjustLeafEdgeWts(tree, leafWts);
  }

  cout << "The tree is: " << endl;
  DFS2(tree);
  cout << endl << endl; 
}


/******* using table class ********************************************/

  void reduceDimension(Table & Data, int I){
    Table newTable(Data.length - 1);
    int flag1 = 0, flag2 = 0;

//     for(int i = 0; i < Data.length; i++){
//       for(int j = 0; j < Data.length; j++) cout << Data.table[i].table[j] << " ";
//       cout << endl;} 
//     cout << endl;
    for(int i = 0; i < (Data.length - 1); i++){
      for(int j = 0; j < (Data.length - 1); j++){
	if(i >= (I - 1)) flag1 = 1;
	else flag1 = 0;
	if(j >= (I - 1)) flag2 = 1;
	else flag2 = 0;

	newTable.table[i].table[j] = Data.table[i + flag1].table[j + flag2];
      } flag1 = 0;
    }

    Data.length--;
    for(int i = 0; i < Data.length; i++)
      for(int j = 0; j < Data.length; j++) Data.table[i].table[j] = newTable.table[i].table[j];

    for(int i = 0; i < newTable.length; i++)
      delete [] newTable.table[i].table;
    delete [] newTable.table;

//     for(int i = 0; i < Data.length; i++){
//       for(int j = 0; j < Data.length; j++) cout << Data.table[i].table[j] << " ";
//       cout << endl;} 
  
  }

void bubblesort2(int n, int * array) {
  for (int i = 0; i < n-1; i++)
    for (int j = n-1; j > i; --j)
      if (array[j] < array[j-1])
	swap(array[j], array[j-1]);
}


void adjustBINJTree1(TreeNode* node, double & tmp){
  if(node != NULL){
    if(node -> flag == 1){
      if(node -> wt != 0){
	tmp = node -> wt;
	node -> wt /= 2.0;
      }
    }
    adjustBINJTree1(node -> right, tmp);
    adjustBINJTree1(node -> left, tmp); 
  }
}

void adjustBINJTree2(TreeNode* node, double & tmp){
  if(node != NULL){
    if(node -> flag == 1){
      if(node -> wt == 0){
	node -> wt = (tmp / 2.0);
      }
    }
    adjustBINJTree2(node -> right, tmp);
    adjustBINJTree2(node -> left, tmp);
  }
}

void CreateTree2_Table(Table Data, int n, int m, int mm, int numOfWeights, char** names)
{
  int N = n, i, counter = 0, cherry1, cherry2, ind[n], index[n], remove[n + 1], removeInd[n], trueInd[n];

  TreeNode * leaves[n], *root1, *root2, *tree;
  Table M(n);

  double leafWts[n];

  for(i = 0; i < n; i++) 
    {  

      leaves[i] = new TreeNode;
      leaves[i] -> name = i + 1;
      leaves[i] -> Allocate(names[i]);

      /* for now, edge weight is 0... */
      leaves[i] -> wt = 0;

      ind[i] = 0; remove[i + 1] = 0; removeInd[i] = 0;
      index[i] = i + 1; trueInd[i] = i + 1; 
    }
  remove[0] = n + 10;

  int counter2 = 0, hold = 0;

  while(N > m){
    // cout << endl << N << endl;
    TreeNode * tmpNode, *newNode;

    findMin2_Table(N, cherry1, cherry2, Data, M, counter, ind, N);
    hold = cherry1;
    remove[counter2 + 1] = cherry2;
    //  trueInd[cherry2 - 1] = n + 10;
    // cout << cherry1 << " " << cherry2 << endl;
    // trueInd[cherry2 - 1] = n + 10;
    bubblesort(n, trueInd);
    //for(int j = 0; j < n; j++) cout << trueInd[j] << " "; cout << endl; 
    cherry1 = trueInd[hold - 1];
    cherry2 = trueInd[remove[counter2 + 1] - 1];
    trueInd[remove[counter2 + 1] - 1] = n + 10;
    removeInd[counter2] = cherry2; 
    counter2++;
    //cout << cherry1 << " " << cherry2 << endl << endl;
    newNode = new TreeNode;
 
    newNode -> left = leaves[cherry1 - 1];
    newNode -> right = leaves[cherry2 - 1];
    leaves[cherry1 - 1] -> parent = newNode;
    leaves[cherry2 - 1] -> parent = newNode;
    EdgeWts_Table(Data, N, m, hold, remove[counter2], leaves[cherry1 - 1] -> wt, leaves[cherry2 - 1] -> wt, N); 

    if(leaves[cherry1 - 1] -> name != -1) leafWts[leaves[cherry1 - 1] -> name - 1] = leaves[cherry1 - 1] -> wt;
    if(leaves[cherry2 - 1] -> name != -1) leafWts[leaves[cherry2 - 1] -> name - 1] = leaves[cherry2 - 1] -> wt;

//     if(mm > 2){
//       adjustInteriorEdgeWts(n, mm, leaves[cherry1 - 1]);
//       adjustInteriorEdgeWts(n, mm, leaves[cherry2 - 1]);
//     }

    /* for now, edge weight is 0... */
    newNode -> wt = 0;
    newNode -> hight = leaves[cherry1 - 1] -> hight + leaves[cherry2 - 1] -> hight; 
     tmpNode = newNode;
     leaves[cherry1 - 1] = tmpNode;

//     DFS2(newNode);
//     cout << endl << endl;

    UpdateTaxa_Table(N, hold, remove[counter2], Data);
    reduceDimension(Data, remove[counter2]);
    N--;
  }
 
  int kk = 0, index3[2];
  index3[0] = 1; index3[1] = 2;
  hold = 1;

  for(i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      if(index[i] == removeInd[j]) index[i] = 0;
    //if(index[i] != 0) cout << index[i] << " ";
   if(index[i] != 0){ index3[kk] = index[i];  kk++;}
  }

  int Flag[2], Flag2 = 0;
  double keepWt;

  Flag[0] = 0, Flag[1] = 0;
  for(i = 0; i < 2; i++)
    if(leaves[index3[i] - 1] -> name != -1){ Flag[i] = 1; Flag2 = 1;}

  for(i = 0; i < 2; i++){ 
  leaves[index3[i] - 1] -> flag = 1;
    if(Flag2 == 1){
      if(Flag[i] == 1){
	leaves[index3[i] - 1] -> wt = Sum2_Table(N, 1, 2, Data);
      }
      leafWts[leaves[index3[i] - 1] -> name - 1] = leaves[index3[i] - 1] -> wt;
    }
  }

  if(Flag2 == 0){    
    leaves[index3[0] - 1] -> wt = Sum2_Table(N, 1, 2, Data);
  }
  if((mm > 2) && (Flag2 == 0)){
    adjustInteriorEdgeWts(n, mm, leaves[index3[0] - 1]);
  }
  
  tree = new TreeNode;
  root1 = clone(leaves[index3[0] - 1], tree);
  root2 = clone(leaves[index3[1] - 1], tree);
  deleteTree(leaves[index3[0] - 1]);
  deleteTree(leaves[index3[1] - 1]);

  tree -> left = root1;
  tree -> right = root2;

  assignNum(tree);
  // printTree(tree, 0); 
  if(mm > 2){
    treeAdjustInteriorEdgeWts(n, mm, tree);
    computingEdgeWts(tree, n, mm, leafWts);
    adjustLeafEdgeWts(tree, leafWts);
  }

  adjustBINJTree1(tree, keepWt);
  adjustBINJTree2(tree, keepWt);

  double tWts = 0.0;
  totalWt(tree, tWts);
  ofstream treefile, WtsFile;
  treefile.open("treefile.dnd");
  printDND(tree, treefile);

  deleteTree(tree);
}

void CreateTree3_Table(Table Data, int n, int m, int mm, int numOfWeights, char** names, char * filename)
{
  int N = n, i, counter = 0, cherry1, cherry2, ind[n], index[n], remove[n + 1], removeInd[n], trueInd[n];

  TreeNode * leaves[n], *root1, *root2, *tree;
  Table M(n);

  double leafWts[n];

  for(i = 0; i < n; i++) 
    {  

      leaves[i] = new TreeNode;
      leaves[i] -> name = i + 1;
      leaves[i] -> Allocate(names[i]);

      /* for now, edge weight is 0... */
      leaves[i] -> wt = 0;

      ind[i] = 0; remove[i + 1] = 0; removeInd[i] = 0;
      index[i] = i + 1; trueInd[i] = i + 1; 
    }
  remove[0] = n + 10;

  int counter2 = 0, hold = 0;

  while(N > m){
    // cout << endl << N << endl;
    TreeNode * tmpNode, *newNode;

    findMin2_Table(N, cherry1, cherry2, Data, M, counter, ind, N);
    hold = cherry1;
    remove[counter2 + 1] = cherry2;
    //  trueInd[cherry2 - 1] = n + 10;
    // cout << cherry1 << " " << cherry2 << endl;
    // trueInd[cherry2 - 1] = n + 10;
    bubblesort(n, trueInd);
    //for(int j = 0; j < n; j++) cout << trueInd[j] << " "; cout << endl; 
    cherry1 = trueInd[hold - 1];
    cherry2 = trueInd[remove[counter2 + 1] - 1];
    trueInd[remove[counter2 + 1] - 1] = n + 10;
    removeInd[counter2] = cherry2; 
    counter2++;
    //cout << cherry1 << " " << cherry2 << endl << endl;
    newNode = new TreeNode;
 
    newNode -> left = leaves[cherry1 - 1];
    newNode -> right = leaves[cherry2 - 1];
    leaves[cherry1 - 1] -> parent = newNode;
    leaves[cherry2 - 1] -> parent = newNode;
    EdgeWts_Table(Data, N, m, hold, remove[counter2], leaves[cherry1 - 1] -> wt, leaves[cherry2 - 1] -> wt, N); 

    if(leaves[cherry1 - 1] -> name != -1) leafWts[leaves[cherry1 - 1] -> name - 1] = leaves[cherry1 - 1] -> wt;
    if(leaves[cherry2 - 1] -> name != -1) leafWts[leaves[cherry2 - 1] -> name - 1] = leaves[cherry2 - 1] -> wt;

//     if(mm > 2){
//       adjustInteriorEdgeWts(n, mm, leaves[cherry1 - 1]);
//       adjustInteriorEdgeWts(n, mm, leaves[cherry2 - 1]);
//     }

    /* for now, edge weight is 0... */
    newNode -> wt = 0;
    newNode -> hight = leaves[cherry1 - 1] -> hight + leaves[cherry2 - 1] -> hight; 
     tmpNode = newNode;
     leaves[cherry1 - 1] = tmpNode;

//     DFS2(newNode);
//     cout << endl << endl;

    UpdateTaxa_Table(N, hold, remove[counter2], Data);
    reduceDimension(Data, remove[counter2]);
    N--;
  }
 
  int kk = 0, index3[2];
  index3[0] = 1; index3[1] = 2;
  hold = 1;

  for(i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      if(index[i] == removeInd[j]) index[i] = 0;
    //if(index[i] != 0) cout << index[i] << " ";
   if(index[i] != 0){ index3[kk] = index[i];  kk++;}
  }

  int Flag[2], Flag2 = 0;
  Flag[0] = 0, Flag[1] = 0;
  for(i = 0; i < 2; i++)
    if(leaves[index3[i] - 1] -> name != -1){ Flag[i] = 1; Flag2 = 1;}
  
  for(i = 0; i < 2; i++){ 
    if(Flag2 == 1){
      if(Flag[i] == 1)
	leaves[index3[i] - 1] -> wt = Sum2_Table(N, 1, 2, Data);
      leafWts[leaves[index3[i] - 1] -> name - 1] = leaves[index3[i] - 1] -> wt;
    }
  }

  if(Flag2 == 0)    
    leaves[index3[0] - 1] -> wt = Sum2_Table(N, 1, 2, Data);
//   if((mm > 2) && (Flag2 == 0)){
//     adjustInteriorEdgeWts(n, mm, leaves[index3[0] - 1]);
//   }
 
  tree = new TreeNode;
  root1 = clone(leaves[index3[0] - 1], tree);
  root2 = clone(leaves[index3[1] - 1], tree);
  deleteTree(leaves[index3[0] - 1]);
  deleteTree(leaves[index3[1] - 1]);

  tree -> left = root1;
  tree -> right = root2;

  assignNum(tree);

//   cout << "\nPhylogenetic tree is: " << endl;
//   DFS2(tree);

  double tWts = 0.0;
  totalWt(tree, tWts);
  ofstream treefile, WtsFile;
  treefile.open(filename);
  printDND(tree, treefile);
  //  cout << "NeighborJoin is done.\nTree is printed in " << filename << "." << endl;
  deleteTree(tree);
}

TreeNode* CreateTree(Table Data, int n, int m, int mm, int numOfWeights, char** names)
{
  int N = n, i, counter = 0, cherry1, cherry2, ind[n], index[n], remove[n + 1], removeInd[n], trueInd[n];

  TreeNode * leaves[n], *root1, *root2, *tree;
  Table M(n);

  double leafWts[n];

  for(i = 0; i < n; i++) 
    {  

      leaves[i] = new TreeNode;
      leaves[i] -> name = i + 1;
      leaves[i] -> Allocate(names[i]);

      /* for now, edge weight is 0... */
      leaves[i] -> wt = 0;

      ind[i] = 0; remove[i + 1] = 0; removeInd[i] = 0;
      index[i] = i + 1; trueInd[i] = i + 1; 
    }
  remove[0] = n + 10;

  int counter2 = 0, hold = 0;

  while(N > m){
    // cout << endl << N << endl;
    TreeNode * tmpNode, *newNode;

    findMin2_Table(N, cherry1, cherry2, Data, M, counter, ind, N);
    hold = cherry1;
    remove[counter2 + 1] = cherry2;
    //  trueInd[cherry2 - 1] = n + 10;
    // cout << cherry1 << " " << cherry2 << endl;
    // trueInd[cherry2 - 1] = n + 10;
    bubblesort(n, trueInd);
    //for(int j = 0; j < n; j++) cout << trueInd[j] << " "; cout << endl; 
    cherry1 = trueInd[hold - 1];
    cherry2 = trueInd[remove[counter2 + 1] - 1];
    trueInd[remove[counter2 + 1] - 1] = n + 10;
    removeInd[counter2] = cherry2; 
    counter2++;
    //cout << cherry1 << " " << cherry2 << endl << endl;
    newNode = new TreeNode;
 
    newNode -> left = leaves[cherry1 - 1];
    newNode -> right = leaves[cherry2 - 1];
    leaves[cherry1 - 1] -> parent = newNode;
    leaves[cherry2 - 1] -> parent = newNode;
    EdgeWts_Table(Data, N, m, hold, remove[counter2], leaves[cherry1 - 1] -> wt, leaves[cherry2 - 1] -> wt, N); 

    if(leaves[cherry1 - 1] -> name != -1) leafWts[leaves[cherry1 - 1] -> name - 1] = leaves[cherry1 - 1] -> wt;
    if(leaves[cherry2 - 1] -> name != -1) leafWts[leaves[cherry2 - 1] -> name - 1] = leaves[cherry2 - 1] -> wt;

//     if(mm > 2){
//       adjustInteriorEdgeWts(n, mm, leaves[cherry1 - 1]);
//       adjustInteriorEdgeWts(n, mm, leaves[cherry2 - 1]);
//     }

    /* for now, edge weight is 0... */
    newNode -> wt = 0;
    newNode -> hight = leaves[cherry1 - 1] -> hight + leaves[cherry2 - 1] -> hight; 
     tmpNode = newNode;
     leaves[cherry1 - 1] = tmpNode;

//     DFS2(newNode);
//     cout << endl << endl;

    UpdateTaxa_Table(N, hold, remove[counter2], Data);
    reduceDimension(Data, remove[counter2]);
    N--;
  }
 
  int kk = 0, index3[2];
  index3[0] = 1; index3[1] = 2;
  hold = 1;

  for(i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      if(index[i] == removeInd[j]) index[i] = 0;
    //if(index[i] != 0) cout << index[i] << " ";
   if(index[i] != 0){ index3[kk] = index[i];  kk++;}
  }

  int Flag[2], Flag2 = 0;
  double keepWt;

  Flag[0] = 0, Flag[1] = 0;
  for(i = 0; i < 2; i++)
    if(leaves[index3[i] - 1] -> name != -1){ Flag[i] = 1; Flag2 = 1;}

  for(i = 0; i < 2; i++){ 
  leaves[index3[i] - 1] -> flag = 1;
    if(Flag2 == 1){
      if(Flag[i] == 1){
	leaves[index3[i] - 1] -> wt = Sum2_Table(N, 1, 2, Data);
      }
      leafWts[leaves[index3[i] - 1] -> name - 1] = leaves[index3[i] - 1] -> wt;
    }
  }

  if(Flag2 == 0){    
    leaves[index3[0] - 1] -> wt = Sum2_Table(N, 1, 2, Data);
  }
  if((mm > 2) && (Flag2 == 0)){
    adjustInteriorEdgeWts(n, mm, leaves[index3[0] - 1]);
  }
  
  tree = new TreeNode;
  root1 = clone(leaves[index3[0] - 1], tree);
  root2 = clone(leaves[index3[1] - 1], tree);
  deleteTree(leaves[index3[0] - 1]);
  deleteTree(leaves[index3[1] - 1]);

  tree -> left = root1;
  tree -> right = root2;

  assignNum(tree);
  // printTree(tree, 0); 
  if(mm > 2){
    treeAdjustInteriorEdgeWts(n, mm, tree);
    computingEdgeWts(tree, n, mm, leafWts);
    adjustLeafEdgeWts(tree, leafWts);
  }

  adjustBINJTree1(tree, keepWt);
  adjustBINJTree2(tree, keepWt);

//   double tWts = 0.0;
//   totalWt(tree, tWts);
//   ofstream treefile, WtsFile;
//   treefile.open("treefile.dnd");
//   printDND(tree, treefile);
  cleanNum1(tree);
  return tree;
}
