/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    December 10th, 2005
 Update:  December 16th, 2005
 Program: This is software for the EMGNJ method with Asger Hobolth.

********************************************************************/

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

#include <lapack++.h>
#include <lapack.h>
#include <lafnames.h>

#include "TreeNode.h"
#include "Mjoin.h"

using namespace std;

void removeDash(Alinements** InputData, int n){
 
  int max_length = 0; 
  max_length = (*InputData)[0].DNA.length(); 
  int counter = 0;
  int Index[max_length];

  for(int i = 0; i < max_length; i++) Index[i] = 0;
   
   //   for(int j = 0; j < n; j++){
   for(int i = 0; i < max_length; i++){
     for(int j = 0; j < n; j++){
       // if((*InputData)[j].DNA[i] == '-')
       if(((*InputData)[j].DNA[i] != 'A') && ((*InputData)[j].DNA[i] != 'G') && ((*InputData)[j].DNA[i] != 'C') && ((*InputData)[j].DNA[i] != 'T'))
	 Index[i] = 1; 
     }
   }

   for(int i = 0; i < max_length; i++){
     for(int j = 0; j < n; j++){
       if(Index[i] == 1)
	 (*InputData)[j].DNA[i] = '-';
     }
   }

//    for(int i = 0; i < n; i++)
//      cout << (*InputData)[i].DNA << endl;
}


int** DNAMat(Alinements* InputData, int n, int & max_length){
  int **Mat, numDash = 0, counter = 0; 
  max_length = InputData[0].DNA.length(); 

  for(int j = 0; j < max_length; j++)
    if(InputData[0].DNA[j] == '-') numDash++;

  Mat = new int*[n];
  for(int i = 0; i < n; i++)
    Mat[i] = new int[max_length - numDash];

  for(int i = 0; i < n; i++){
    counter = 0;
     for(int j = 0; j < max_length; j++){
       if(InputData[i].DNA[j] != '-'){
	 if(InputData[i].DNA[j] == 'A')
	   Mat[i][counter] = 1;
	 else if(InputData[i].DNA[j] == 'G')
	   Mat[i][counter] = 2;
	 else if(InputData[i].DNA[j] == 'C')
	   Mat[i][counter] = 3;
	 else if(InputData[i].DNA[j] == 'T')
	   Mat[i][counter] = 4;
	 else{
	   cerr << "Sequences contains non A, G, C, T letters!" << endl;
	   cerr << "It contains: " << InputData[i].DNA[j] << endl; 
	   exit(0);
	 }
	 counter++;
       }
     }
  }


  max_length -= numDash;

//   char DNA[5] = "AGCT";
//   cout << n << " " << max_length << endl;
//   for(int i = 0; i < n; i++){
//     cout << InputData[i].name << " ";
//     for(int j = 0; j < 10; j++) cout << " ";
//      for(int j = 0; j < max_length; j++)
//        cout << DNA[Mat[i][j]-1];
//      cout << endl;
//        }
 
//   for(int i = 0; i < n; i++){
//      for(int j = 0; j < max_length; j++)
//        cout << Mat[i][j] << " ";
//      cout << endl;
//        }


  return Mat;
}

int*** DNAMat(Alinements* InputData, int n, int & max_length, 
	      long long int choose, int** subsets){
  //here n is the size of subtree....
  int ***Mat, numDash = 0, counter = 0; 
  max_length = InputData[0].DNA.length(); 

  for(int j = 0; j < max_length; j++)
    if(InputData[0].DNA[j] == '-') numDash++;

  Mat = new int**[choose];
  for(int i = 0; i < choose; i++)
    Mat[i] = new int*[n];
  for(int j = 0; j < choose; j++)
    for(int i = 0; i < n; i++)
      Mat[j][i] = new int[max_length - numDash];


  for(int I = 0; I < choose; I++){
    for(int i = 0; i < n; i++){
      counter = 0;
      for(int j = 0; j < max_length; j++){
	if(InputData[subsets[I][i] - 1].DNA[j] != '-'){
	  if(InputData[subsets[I][i] - 1].DNA[j] == 'A')
	    Mat[I][i][counter] = 1;
	  else if(InputData[subsets[I][i] - 1].DNA[j] == 'G')
	   Mat[I][i][counter] = 2;
	  else if(InputData[subsets[I][i] - 1].DNA[j] == 'C')
	    Mat[I][i][counter] = 3;
	  else if(InputData[subsets[I][i] - 1].DNA[j] == 'T')
	    Mat[I][i][counter] = 4;
	  else{
	    cerr << "Sequences contains non A, G, C, T letters!" << endl;
	    cerr << "It contains: " << InputData[i].DNA[j] << endl; 
	    exit(0);
	  }
	  counter++;
	}
      }
    }
  }
  
  max_length -= numDash;
  return Mat;
}

