/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    June 6th, 2004
 Update:  June 6th, 2004
 
Comments: This function generates all m-subsets from [n].

***********************************************************************/

#ifndef SUBSET__H
#define SUBSET__H

#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>

using namespace std;
 
// Function Subsets() that finishes creating subsets of size M,
// by choosing (M-K) elements from {I, I+1,, ..., N-1},
// where K elements have already been chosen in advance
// from {0, 1, ..., I-1} and stored in array[]
 
 
void Subsets(int N, int M, int I, int K, int *array, ofstream & out)
{
    //If we have already excluded too many items, then return
  
    if((M-K) == (N-I+1))
         return;
 
 
    //if we have finished comuting a subset, then print it out
     
    if((M-K) == 0)
    {
        for(int i = 0; i < N; i++)
             if(array[i] == 1)
                 out << i << "  ";
 
         out << endl;
         return;
     }
 
 
        
    int newArray[N];
    for(int i = 0; i < N; i++) newArray[i] = 0;
 
    //copy the K precomputed values from array[]
 
    for(int i = 0; i < I; i++)
        newArray[i] = array[i];
 
 
     //compute all subsets where we choose element I
     newArray[I] = 1;
     Subsets(N, M, I+1, K+1, newArray, out);
 
     //compute all subsets where we DON'T choose element I
     newArray[I] = 0;
     Subsets(N, M, I+1, K, newArray, out);
 
    return;
    
 
}
 
 
int getList(int N, int M){

  int array[N];

  for(int i = 0; i < N; i++) array[i] = 0;
  //Print out all subsets of size M
 
  ofstream out;
  out.open("ListOfSubsets");

  Subsets(N, M, 0, 0, array, out);

  return 0;
}

#endif
