/*********************************************************************
 Author:  Ruriko Yoshida
 Date:    August 7th, 2004
 Update:  January 22nd, 2005
  
***********************************************************************/
#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <string>
#include <math.h>
#include <algorithm>
#include <time.h>

#include "Index.h"
#include "Cherry.h"
#include "TreeTable.h"

using namespace std;

double Sum1_Table(int n, int i, Table data){

  double sum = 0;
  int numOfrows = n - 1, j = 0;
  int index[numOfrows][2];
  
  sum = 0;
  for(j = 0; j < numOfrows; j++){
    if(i == (j + 1))
      index[j][0] = n;
    else index[j][0] = j + 1;
      index[j][1] = i;
      // bubblesort(2, index[j]);
      
      sum += data.table[index[j][0] - 1].table[index[j][1] - 1];
        
  } 

  return sum;
  
}

double Sum2_Table(int n, int i, int j, Table data){

  return data.table[i - 1].table[j - 1];
  
}

double CherryPicking_Table(int n, int i, int j, Table data, int N){
  double mVal = 0;
  mVal = (N - 2); //cout << N - 2 << endl;
  mVal /= (2 - 1);//cout << mVal << endl;
  mVal *= Sum2_Table(n, i, j, data);
  mVal -= (Sum1_Table(n, i, data) + Sum1_Table(n, j, data));

  return mVal;
}

void getMatrix2_Table(int n, Table data, Table & M, int counter, int* ind, int N){

  for(int i = 0; i < n; i++)
    for(int j = 0; j < n; j++) M.table[i].table[j]= 1000;

    for(int i = 0; i < n; i++)
      for(int j = i + 1; j < n; j++){
	if(i != j) 
	  M.table[i].table[j] = CherryPicking_Table(n, i + 1, j + 1, data, N);
	else M.table[i].table[j] = 1000;
      }
    
//     for(int k = 0; k <= counter; k++)
//       for(int i = 0; i < n; i++)
// 	if((ind[k] - 1) > 0)
// 	  {
// 	    M.table[i].table[ind[k] - 1] = 1000;
// 	    M.table[ind[k] - 1].table[i] = 1000;
// 	  }

}

void findMin2_Table(int n, int & I, int & J, Table data, Table M, int& counter, int* ind, int N){

  double min = 10000;

  getMatrix2_Table(n, data, M, counter, ind, N);

  for(int i = 0; i < n; i++)
    for(int j = i + 1; j < n; j++){
      //      cout << n - i << " " << n - j << endl;
      if(min > M.table[i].table[j])
	{ min = M.table[i].table[j];
	I = i + 1;
	J = j + 1;
	} 
    }
  counter++;
  ind[counter] = J;
}
 
void UpdateTaxa_Table(int n, int I, int J, Table & data){
  int numOfrows = n - 1, j = 0, k = 0;
  int index[numOfrows][2], index2[numOfrows][2];
  int index3[2];
  index3[0] = I;
  index3[1] = J;

  double tmp = -(data.table[index3[0] - 1].table[index3[1] - 1]/2.0);
 
  for(j = 0; j < numOfrows; j++){
    if((j + 1) == I)
      index[j][0] = n;
    else index[j][0] = j + 1;
      index[j][1] = I;

    for(k = 0; k < 2; k++){
      if(index[j][k] == I) index2[j][k] = J;
      else if(index[j][k] == J) index2[j][k] = I;
      else index2[j][k] = index[j][k];
    }

    data.table[index[j][0] - 1].table[index[j][1] - 1] = (data.table[index[j][0] - 1].table[index[j][1] - 1] + data.table[index2[j][0] - 1].table[index2[j][1] - 1])/2;


    if(data.table[index[j][0] - 1].table[index[j][1] - 1] > 0)
      data.table[index[j][0] - 1].table[index[j][1] - 1] += tmp;

    data.table[index[j][1] - 1].table[index[j][0] - 1] = data.table[index[j][0] - 1].table[index[j][1] - 1];
    
    data.table[index2[j][0] - 1].table[index2[j][1] - 1] = 0;
    data.table[index2[j][1] - 1].table[index2[j][0] - 1] = 0;

  }
  
  
}

void EdgeWts_Table(Table Data, int n, int m, int i, int j, double & wts1, double & wts2, int N){
  double tmp = 0;
  wts1 = Sum2_Table(n, i, j, Data)/2;
  tmp = ((Sum1_Table(n, i, Data)) - Sum1_Table(n, j, Data));
  tmp = tmp/2;
  tmp /= (N - 2);
  wts1 += tmp;
  wts2 = Sum2_Table(n, i, j, Data) - wts1; 
}


void CreateTreeMatric_Table(Taxa * Data, int n, int m, Table & S){
  int i, j;
  for(i = 0; i < n; i++){
    for(j = i + 1; j < n; j++){
      S.table[i].table[j] = newSum2(n, m, i + 1, j + 1, Data);
      S.table[j].table[i] = S.table[i].table[j];
    }
    S.table[i].table[i] = 0.0;
  }
}

void createMatFile(char* filename, char** names, int n, Table S){

  ofstream out(filename);
  if(!out){
    cerr << "Writing proble on createMatFile function." << endl;
    exit(0);
  }
  out << n << endl;
  for(int i = 0; i < n; i++){
    out << names[i] << endl;
    for(int j = 0; j < n; j++){
      out.precision(8);
      out << fixed << S.table[i].table[j] << " ";
    }
    out << endl;
  }
}

