#include <fstream.h>
#include <iostream.h>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <algorithm>
#include <time.h>
#include <list.h>

#include "TreeNode.h"

using namespace std;

long long int Choose(int n, int m){
  long long int f = 1, i;
  long long int numOfWts = 0;
  if(n == 0) return 0;
  else{
    if(m <= n/2){
      for(i = 0; i < m; i++)  f *= (n - i);
      for(i = 1; i <= m; i++) f /= i;
    }
    else{
      int mm = n - m;
      for(i = 0; i < mm; i++)  f *= (n - i);
      for(i = 1; i <= mm; i++) f /= i;
    }
    numOfWts = f;
    
    return numOfWts;
  }
}


void readNewick(ifstream & in, TreeNode * node, int & num, int & n){
  char tmp, *holding, *holding2;
  holding = new char[200];
  holding2 = new char[200];
  int counter = 0;
  if(!in.eof()){
    in >> tmp;
    if(tmp != ';'){
      if(tmp == '('){
	
	TreeNode * left = new TreeNode;
	TreeNode * right = new TreeNode;
	node -> left = left;
	node -> right = right;
	left -> parent = node;
	right -> parent = node; 
	readNewick(in, left, num, n);
      }
      else if(tmp == ':'){
	counter = 0;
	while((tmp != ',') && (tmp != ')')){
	  in >> tmp;
	  if((tmp != ',') && (tmp != ')'))
	    holding2[counter] = tmp;
	  counter++;
	}
	node -> wt = atof(holding2);
	
	if(tmp == ','){
	  if(node -> parent -> right -> wt == -10000)
	    readNewick(in, node -> parent -> right, num, n);
	  else {
	    TreeNode * middle = new TreeNode;
	    node -> parent -> middle = middle;
	    middle -> parent = node;
	    readNewick(in, middle, num, n);
	  }
	}
	//	  readNewick(in, node -> parent -> right, num, n);
	else if(tmp == ')')
	  readNewick(in, node -> parent, num, n);
      }
      else{
	holding[0] = tmp; counter++;
	while(tmp != ':'){
	  in >> tmp;
	  if(tmp != ':')
	    holding[counter] = tmp;
	  counter++;
	} 
	node -> Allocate(holding);
	node -> wt = atof(holding2);
	node -> name = atoi(holding);
	num++; n++;
	counter = 0; 
	while((tmp != ',') && (tmp != ')')){
	  in >> tmp;
	  if((tmp != ',') && (tmp != ')'))
	    holding2[counter] = tmp;
	  counter++;
	}
	node -> wt = atof(holding2);node -> wt = atof(holding2);
	if(tmp == ','){
	  if(node -> parent -> right -> wt == -10000)
	    readNewick(in, node -> parent -> right, num, n);
	  else {
	    TreeNode * middle = new TreeNode;
	    node -> parent -> middle = middle;
	    middle -> parent = node;
	    readNewick(in, middle, num, n);
	  }
	}
	//if(tmp == ',')
	//  readNewick(in, node -> parent -> right, num, n);
	else if(tmp == ')')
	  readNewick(in, node -> parent, num, n);
      }
//       delete [] holding;
//       delete [] holding2;
    }
  }

//   delete [] holding;
//   delete [] holding2;
}



long double getSubtreeWt(int** TreeMatrix, int n, int m, int* lvIndex, 
		       double* Brlen){

  list<int> lvs, parents, newLvs, hold;
  long double wt = 0.0;
  list<int>::iterator nums_iter, nums_iter2, nums_iter3;
  int numLv = (2 * m) - 1, numOfSubtree = Choose(n, m), 
    root = (2 * n) - 1, tmp = 0, left = 0, right = 0;

  for(int i = 0; i < m; i++){
    lvs.push_back(lvIndex[i]); newLvs.push_back(lvIndex[i]);
  }

//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }
  for(int i = 0; i < m; i++)
    parents.push_back(TreeMatrix[lvIndex[i] - 1][3]);

//   for(int i = 0; i < m; i++) cout << leaves[i] << " ";
//   cout << endl;

//   for(int i = 0; i < (2*n - 1); i++){
//     for(int j = 0; j < 4; j++){
//       cout << TreeMatrix[i][j] << " ";
//     }
//     cout << endl;
//   }cout << endl;

//   for(nums_iter = parents.begin(); nums_iter != parents.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }

//   exit(0);
  while(!parents.empty()){

    tmp = parents.front();
    //    cout << tmp << endl;
    parents.pop_front();
    
    nums_iter = find(parents.begin(), parents.end(), TreeMatrix[tmp - 1][3]);
    if(nums_iter == parents.end())
      if(TreeMatrix[tmp - 1][3] != 0)
	parents.push_back(TreeMatrix[tmp - 1][3]);
    
    nums_iter = find(lvs.begin(), lvs.end(), tmp);

    if(nums_iter == lvs.end()){
      lvs.push_back(tmp);
    }
  }

  lvs.sort();
//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }exit(0);

  while(!lvs.empty()){
    tmp = lvs.back();
    //cout << tmp << endl;
    lvs.pop_back(); 
    parents.push_back(tmp);
    left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
    right =  TreeMatrix[tmp - 1][2];//cout << right << endl; 

    nums_iter2 = find(lvs.begin(), lvs.end(), left);
    nums_iter3 = find(lvs.begin(), lvs.end(), right);
    if((nums_iter2 != lvs.end()) && (nums_iter3 != lvs.end()))
      hold.push_back(tmp);
  }

  hold.sort();

  root = hold.back();
  //    cout << root << endl; exit(0);
  hold.push_front(root);
  parents.sort();

  hold.clear();

  while(!parents.empty()){
    tmp = parents.back();
    //cout << tmp << endl;
    parents.pop_back(); 
    if(tmp <= root){
      left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
      right =  TreeMatrix[tmp - 1][2];//cout << right << endl << endl;
      nums_iter2 = find(parents.begin(), parents.end(), left);
      nums_iter3 = find(parents.begin(), parents.end(), right);
      if(nums_iter2 != parents.end())
	hold.push_front(tmp);
      if(nums_iter3 != parents.end())
	hold.push_front(tmp);
    }
  }

  while(!hold.empty()){
    tmp = hold.back();
    //cout << tmp << endl;
    hold.pop_back();
    nums_iter = find(newLvs.begin(), newLvs.end(), tmp);
    if(nums_iter == newLvs.end())
      newLvs.push_front(tmp);
  }

  newLvs.sort();
  newLvs.pop_back();
  for(nums_iter = newLvs.begin(); nums_iter != newLvs.end(); nums_iter++)
  {
    wt += Brlen[(*nums_iter) - 1];
    //cout << (*nums_iter) << endl;
  }
  //  if(newLvs.back() != (2*n - 1)) wt -= Brlen(newLvs.back() - 1);
  newLvs.clear();

  //cout << wt << endl;
  return wt;
}

void DFS3(TreeNode* node){
  if(node != 0){
      if(node -> wt != -10000){
	if(node -> name == -1)
	  {
	    cout << "(";
	    DFS3(node -> left);
	    cout << ",";
	    if(node -> middle != 0){
	      DFS3(node -> middle);
	      cout << ",";
	    }
	    DFS3(node -> right);
	    cout << ")";
	    cout << ":";
	    cout << fixed << node -> wt << ":" << node -> num;
	  }      
	else {
	  cout << node -> name;
	  cout << ":";
	  cout << fixed << node -> wt;
	}
      }
      else {
	cout << "(";
	DFS3(node -> left);
	cout << ",";
	if(node -> middle != 0){
	  DFS3(node -> middle);
	  cout << ",";
	}
	DFS3(node -> right);
	cout << ");" << endl;
      }
    }
}

int getMRCA(int** TreeMatrix, int n, int m, int* lvIndex, 
		       double* Brlen){

  list<int> lvs, parents, newLvs, hold;
  long double wt = 0.0;
  list<int>::iterator nums_iter, nums_iter2, nums_iter3;
  int numLv = (2 * m) - 1, numOfSubtree = Choose(n, m), 
    root = (2 * n) - 1, tmp = 0, left = 0, right = 0;

  for(int i = 0; i < m; i++){
    lvs.push_back(lvIndex[i]); newLvs.push_back(lvIndex[i]);
  }

//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }
  for(int i = 0; i < m; i++)
    parents.push_back(TreeMatrix[lvIndex[i] - 1][3]);

//   for(int i = 0; i < m; i++) cout << leaves[i] << " ";
//   cout << endl;

//   for(int i = 0; i < (2*n - 1); i++){
//     for(int j = 0; j < 4; j++){
//       cout << TreeMatrix[i][j] << " ";
//     }
//     cout << endl;
//   }cout << endl;

//   for(nums_iter = parents.begin(); nums_iter != parents.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }

//   exit(0);
  while(!parents.empty()){

    tmp = parents.front();
    //    cout << tmp << endl;
    parents.pop_front();
    
    nums_iter = find(parents.begin(), parents.end(), TreeMatrix[tmp - 1][3]);
    if(nums_iter == parents.end())
      if(TreeMatrix[tmp - 1][3] != 0)
	parents.push_back(TreeMatrix[tmp - 1][3]);
    
    nums_iter = find(lvs.begin(), lvs.end(), tmp);

    if(nums_iter == lvs.end()){
      lvs.push_back(tmp);
    }
  }

  lvs.sort();
//   for(nums_iter = lvs.begin(); nums_iter != lvs.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << endl;
//   }exit(0);

  while(!lvs.empty()){
    tmp = lvs.back();
    //cout << tmp << endl;
    lvs.pop_back(); 
    parents.push_back(tmp);
    left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
    right =  TreeMatrix[tmp - 1][2];//cout << right << endl; 

    nums_iter2 = find(lvs.begin(), lvs.end(), left);
    nums_iter3 = find(lvs.begin(), lvs.end(), right);
    if((nums_iter2 != lvs.end()) && (nums_iter3 != lvs.end()))
      hold.push_back(tmp);
  }

  hold.sort();

  root = hold.back();
  //    cout << root << endl; exit(0);
  hold.push_front(root);
  parents.sort();

  hold.clear();

  while(!parents.empty()){
    tmp = parents.back();
    //cout << tmp << endl;
    parents.pop_back(); 
    if(tmp <= root){
      left =  TreeMatrix[tmp - 1][1]; //cout << left << endl;
      right =  TreeMatrix[tmp - 1][2];//cout << right << endl << endl;
      nums_iter2 = find(parents.begin(), parents.end(), left);
      nums_iter3 = find(parents.begin(), parents.end(), right);
      if(nums_iter2 != parents.end())
	hold.push_front(tmp);
      if(nums_iter3 != parents.end())
	hold.push_front(tmp);
    }
  }

  while(!hold.empty()){
    tmp = hold.back();
    //cout << tmp << endl;
    hold.pop_back();
    nums_iter = find(newLvs.begin(), newLvs.end(), tmp);
    if(nums_iter == newLvs.end())
      newLvs.push_front(tmp);
  }

  newLvs.sort();
  int MRCA = 0;
  MRCA = newLvs.back();
  newLvs.pop_back();
  for(nums_iter = newLvs.begin(); nums_iter != newLvs.end(); nums_iter++)
  {
    wt += Brlen[(*nums_iter) - 1];
    //cout << (*nums_iter) << endl;
  }
  //  if(newLvs.back() != (2*n - 1)) wt -= Brlen(newLvs.back() - 1);
  newLvs.clear();

  //cout << wt << endl;
  return MRCA;
}


void preTreeMatrix(TreeNode* node, int** TreeMatrix, double *BrLenV){
  if(node != NULL){ 
    if(node -> name != -1){
      TreeMatrix[node -> num - 1][0] = 1;
      TreeMatrix[node -> num - 1][3] = node -> parent -> num;
      BrLenV[node -> num - 1] = node -> wt;
    }
    else{
      TreeMatrix[node -> num - 1][1] = node -> left -> num;
      TreeMatrix[node -> num - 1][2] = node -> right -> num;
      if(node -> wt != -10000){
	TreeMatrix[node -> num - 1][3] = node -> parent -> num;
	BrLenV[node -> num - 1] = node -> wt;
      }
    }
    preTreeMatrix(node -> left, TreeMatrix, BrLenV);
    preTreeMatrix(node -> right, TreeMatrix, BrLenV);
  }
}

void TreeMatrixfun(int** TreeMatrix, TreeNode* tree, int N, 
		double *BrLenV){
  for(int i = 0; i < N; i++)
    for(int j = 0; j < 4; j++) TreeMatrix[i][j] = 0;
  
  preTreeMatrix(tree, TreeMatrix, BrLenV);
}

void assignLeafLevel(TreeNode* node, int & h){
  if(node != NULL){
    if(node -> wt != -10000){
      node -> hight = node -> parent -> hight + 1;
    }
    if(node -> hight > h) h = node -> hight;
      assignLeafLevel(node -> right, h);
      assignLeafLevel(node -> left, h);
  }
}

void countNumber(TreeNode* node, int * data){
  if(node != NULL){
    if(node -> name == -1)
      data[node -> hight]++;
    countNumber(node -> right, data);
    countNumber(node -> left, data);
    countNumber(node -> middle, data);
  }
}

void preAssignNum(TreeNode* node, int * data, int * nodes, int N){
  if(node != NULL){
    if(node -> name != -1){
      node -> num = node -> name;
      nodes[node -> num - 1] = 0;
    }
    else{
      if(node -> wt == -10000){
	node -> num = N;
	nodes[N - 1] = 0;
      }
      else{
	int sum = 0, j = 0;
	for(int i = 0; i < (node -> hight - 1); i++) sum += data[i];
	while(nodes[N - 1 - sum - j] == 0) j++;
	node -> num = N - sum - j;
	nodes[N - 1 - sum - j] = 0;
      }
    }
    preAssignNum(node -> left, data, nodes, N);
    preAssignNum(node -> right, data, nodes, N);
    preAssignNum(node -> middle, data, nodes, N);
  }
}

void assignNum(TreeNode* node, int h, int n){
  int N = 2 * n - 1;
  int data[h], nodes[N];
  for(int i = 0; i < h; i++) data[i] = 0;
  for(int i = 0; i < N; i++) nodes[i] = 1;
  countNumber(node, data);
  preAssignNum(node, data, nodes, N);

}

void listNumTree(TreeNode* tree, char** Names){
  if(tree != NULL){
    if(tree -> name != -1){
      Names[tree -> name - 1] = new char[strlen(tree -> RealName) + 1];
      strcpy(Names[tree -> name - 1], tree -> RealName);
    }
    listNumTree(tree -> left, Names);
    listNumTree(tree -> right, Names);
    listNumTree(tree -> middle, Names);
  }
}

void reNumTree(char** Names, TreeNode* node, int n){
  if(node != NULL){ 
    if(node -> name != -1){
      for(int i = 0; i < n; i++){
	//cout << node -> RealName << " " << Names[i] << " " << i << endl;
	if(strcmp(node -> RealName, Names[i]) == 0){
	  //cout << i + 1 << endl;
	  node -> name = i + 1;
	  node -> num = i + 1;   
	}
      }
    }
    reNumTree(Names, node -> left, n);
    reNumTree(Names, node -> right, n);
  }
}

double FR_distanceOld(ifstream & in,  ifstream & in2){
  double dis = 0.0;
  int n = 0, num = 1, n2 = 0, num2 = 1, pairs[2], h = 0;
  char** Names;

  TreeNode * tree1 = new TreeNode;
  TreeNode * tree2 = new TreeNode;

  // ifstream in(filename1), in2(filename2);
  if(!in){
    cerr << "Exter the tree file!" << endl;
    exit(1);
  }

  if(!in2){
    cerr << "Exter the tree file 2!" << endl;
    exit(1);
  }

  readNewick(in, tree1, num, n);
  //  DFS3(tree1);
  readNewick(in2, tree2, num2, n2);
  //  DFS3(tree2);

  double M1[n][n], M2[n2][n2], BrLenV1[2 * n - 2], BrLenV2[2 * n2 - 2];
  int ** TreeMat1, **TreeMat2;
  Names = new char*[n];
  TreeMat1 = new int*[(2 * n - 1)];
  for(int i = 0; i < (2 * n - 1); i++) TreeMat1[i] = new int[4];
  TreeMat2 = new int*[(2 * n2 - 1)];
  for(int i = 0; i < (2 * n2 - 1); i++) TreeMat2[i] = new int[4];
  //cout << n << " " << n2 << endl;exit(0);
  assignLeafLevel(tree1, h);
  assignNum(tree1, h, n);
  TreeMatrixfun(TreeMat1, tree1, 2 * n - 1, BrLenV1);
  listNumTree(tree1, Names); 
  // for(int i = 0; i < n; i++) cout << Names[i] << endl; exit(0);
  reNumTree(Names, tree2, n);
 
  h = 0;
  assignLeafLevel(tree2, h);
  assignNum(tree2, h, n2);
  // exit(0);
  TreeMatrixfun(TreeMat2, tree2, 2 * n2 - 1, BrLenV2);
 
  for(int i = 0; i < n; i++){
    for(int j = (i + 1); j < n; j++){
      pairs[0] = i + 1;
      pairs[1] = j + 1;
      M1[i][j] = getSubtreeWt(TreeMat1, n, 2, pairs, BrLenV1);
      M1[j][i] = M1[i][j];
    }
  }

  for(int i = 0; i < n2; i++){
    for(int j = (i + 1); j < n2; j++){
      pairs[0] = i + 1;
      pairs[1] = j + 1;
      M2[i][j] = getSubtreeWt(TreeMat2, n2, 2, pairs, BrLenV2);
      M2[j][i] = M2[i][j];
    }
  }

  for(int i = 0; i < n; i++) M1[i][i] = 0.0;
  for(int i = 0; i < n2; i++) M2[i][i] = 0.0;

  ofstream out("outfile");
  out << n << endl;
  for(int i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      out << M1[i][j] << " ";
    out << endl;
  }
  for(int i = 0; i < n2; i++){
    for(int j = 0; j < n2; j++)
      out << M2[i][j] << " ";
    out << endl;
  }

  ofstream inPutFile("in");
  char command[200];

  inPutFile << "outfile" << endl;
  inPutFile << "out" << endl;
  inPutFile << 2 << endl;
  strcpy(command, "./Robinson_and_Foulds < in > jnk");
  system(command);
  ifstream in3("out");
  in3 >> dis;

  return dis;
}

void CompBrLen(TreeNode* node, double* BrLen){
  if(node != NULL){
    if(node -> wt != -10000)
      BrLen[node -> num - 1] = node -> wt;
    CompBrLen(node -> left, BrLen);
    CompBrLen(node -> right, BrLen);
    CompBrLen(node -> middle, BrLen);
  }
}

void findLeaf(TreeNode* node, TreeNode** newNode, int i){
  if(node != NULL){
    if(node -> name == i) (*newNode) = node;
    else {
      findLeaf(node -> left, newNode, i);
      findLeaf(node -> right, newNode, i);
      findLeaf(node -> middle, newNode, i);
    }
  }
}

void compList(TreeNode* node, list<int> & lis){
  if(node != NULL){
    if(node -> wt != -10000) lis.push_back(node -> num);
    compList(node -> parent, lis);
  }
}

double compPairD(TreeNode* tree, int i, int j, double* BrLen1){
  list<int> nodeList1, nodeList2;
  list<int>::iterator nums_iter, nums_iter2;
  double BrLen = 0.0;
  TreeNode * node1, * node2;
  findLeaf(tree, &node1, i);
  findLeaf(tree, &node2, j);
  compList(node1, nodeList1);
  compList(node2, nodeList2);
//   cout << node1 -> name << " " <<  node2 -> name << endl;
//   for(nums_iter = nodeList1.begin(); nums_iter != nodeList1.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;
//   for(nums_iter = nodeList2.begin(); nums_iter != nodeList2.end(); nums_iter++)
//   {
//     cout << (*nums_iter) << " ";
//   }cout << endl;
  for(nums_iter = nodeList1.begin(); nums_iter != nodeList1.end(); nums_iter++)
    BrLen += BrLen1[(*nums_iter) - 1];
  for(nums_iter = nodeList2.begin(); nums_iter != nodeList2.end(); nums_iter++)
    BrLen += BrLen1[(*nums_iter) - 1];

  for(nums_iter = nodeList1.begin(); nums_iter != nodeList1.end(); nums_iter++){
    nums_iter2 = find(nodeList2.begin(), nodeList2.end(), (*nums_iter));
    if(nums_iter2 != nodeList2.end())
      BrLen -= 2 * BrLen1[(*nums_iter2) - 1];
      }
  return BrLen;
}

double FR_distance(ifstream & in,  ifstream & in2){
  double dis = 0.0;
  int n = 0, num = 1, n2 = 0, num2 = 1, pairs[2], h = 0;
  char** Names;

  TreeNode * tree1 = new TreeNode;
  TreeNode * tree2 = new TreeNode;

  // ifstream in(filename1), in2(filename2);
  if(!in){
    cerr << "Exter the tree file!" << endl;
    exit(1);
  }

  if(!in2){
    cerr << "Exter the tree file 2!" << endl;
    exit(1);
  }

  readNewick(in, tree1, num, n);
  //  DFS3(tree1);
  readNewick(in2, tree2, num2, n2);
  //  DFS3(tree2);

  double M1[n][n], M2[n2][n2], BrLenV1[2 * n - 2], BrLenV2[2 * n2 - 2];
  int ** TreeMat1, **TreeMat2;
  Names = new char*[n];
  TreeMat1 = new int*[(2 * n - 1)];
  for(int i = 0; i < (2 * n - 1); i++) TreeMat1[i] = new int[4];
  TreeMat2 = new int*[(2 * n2 - 1)];
  for(int i = 0; i < (2 * n2 - 1); i++) TreeMat2[i] = new int[4];
  //cout << n << " " << n2 << endl;exit(0);
  assignLeafLevel(tree1, h);
  assignNum(tree1, h, n);
  //DFS3(tree1);
  listNumTree(tree1, Names); 
  // for(int i = 0; i < n; i++) cout << Names[i] << endl; exit(0);
  reNumTree(Names, tree2, n);
 
  h = 0;
  assignLeafLevel(tree2, h);
  assignNum(tree2, h, n2);
  CompBrLen(tree1, BrLenV1);
  CompBrLen(tree2, BrLenV2);
//   for(int i = 0; i < (2 * n - 2); i++)
//     cout << BrLenV1[i] << " ";
//   cout << endl;
//   for(int i = 0; i < (2 * n2 - 2); i++)
//     cout << BrLenV2[i] << " ";
//   cout << endl;

  for(int i = 0; i < n; i++){
    for(int j = (i + 1); j < n; j++){
      // cout << compPairD(tree1, i + 1, j + 1, BrLenV1) << endl;;
      M1[i][j] = compPairD(tree1, i + 1, j + 1, BrLenV1);
//       pairs[0] = i + 1;
//       pairs[1] = j + 1;
//       M1[i][j] = getSubtreeWt(TreeMat1, n, 2, pairs, BrLenV1);
      M1[j][i] = M1[i][j];
    }
  }

  for(int i = 0; i < n2; i++){
    for(int j = (i + 1); j < n2; j++){
//       pairs[0] = i + 1;
//       pairs[1] = j + 1;
//       M2[i][j] = getSubtreeWt(TreeMat2, n2, 2, pairs, BrLenV2);
      M2[i][j] = compPairD(tree2, i + 1, j + 1, BrLenV2);
      M2[j][i] = M2[i][j];
    }
  }

  for(int i = 0; i < n; i++) M1[i][i] = 0.0;
  for(int i = 0; i < n2; i++) M2[i][i] = 0.0;

  ofstream out("outfile");
  out << n << endl;
  for(int i = 0; i < n; i++){
    for(int j = 0; j < n; j++)
      out << M1[i][j] << " ";
    out << endl;
  }
  for(int i = 0; i < n2; i++){
    for(int j = 0; j < n2; j++)
      out << M2[i][j] << " ";
    out << endl;
  }

  ofstream inPutFile("in");
  char command[200];

  inPutFile << "outfile" << endl;
  inPutFile << "out" << endl;
  inPutFile << 2 << endl;
  strcpy(command, "./Robinson_and_Foulds < in > jnk");
  system(command);
  ifstream in3("out");
  in3 >> dis;

  return dis;
}


double MaxPairDis(ifstream & in){
  double dis = 0.0;
  int n = 0, l = 0, max = 0, diff = 0;
  string st;
  ofstream out("TreeFile.mfa");

  in >> n >> l;
  //  cout << n << " " << l << endl;
  char DNA[n][l];
  for(int i = 0; i < n; i++){
    in >> st; out << ">" << st << endl;
    for(int j = 0; j < l; j++){
      in >> DNA[i][j];
      out << DNA[i][j];
    } out << endl;
  }
//   for(int i = 0; i < n; i++){
//     for(int j = 0; j < l; j++)
//       cout << DNA[i][j] << " ";
//     cout << endl;
//   }
  for(int i = 0; i < n; i++){
    for(int j = (i + 1); j < n; j++){
      diff = 0;
      for(int k = 0; k < l; k++)
	if(DNA[i][k] != DNA[j][k]) diff++;
      if(max < diff) max = diff;
    }
  }
  dis = ((double) max)/((double) l);
  //  cout << dis << endl;
  return dis;
}
void deleteTree(TreeNode* tree){
   if( tree != NULL )
   {
     deleteTree( tree -> left );
     deleteTree( tree -> right );
     delete tree;
     tree = NULL;
   }
}


/* ----------------------------------------------------------------- */
int main(int argc, char *argv[]) {
  double logL = 0.0, dis = 0.0, MPD = 0.0;
  char command[200], outfile[200];
  int numOfTrees = 10000, n = 25, n2 = 0, num = 0, num2 = 0; 

  if(argc < 3){
    cerr << "Enter file names!" << endl;
    exit(1);
  }
  ifstream in, in2;

  in.open(argv[1]);
  if(!in){
    cerr << "Enter the tree file 1!" << endl;
    exit(1);
  }
  in2.open(argv[2]);
  if(!in2){
    cerr << "Enter the tree file 2!" << endl;
    exit(1);
  }
  TreeNode * tree1, *tree2;
  int Pairs[(2 * n - 1)][(2 * n - 1)];
  for(int i = 0; i < (2 * n - 1); i++)
    for(int j = 0; j < (2*n - 1); j++)
      Pairs[i][j] = 0;
  
  int max = 0, min = 100000;  int Max = 0, Min = 0;
  n2 = 25;
  double BrLenV1[2 * n - 2], BrLenV2[2 * n2 - 2];
  int ** TreeMat1, **TreeMat2;
  int h = 0, pairs[2];
  TreeMat1 = new int*[(2 * n - 1)];
  for(int i = 0; i < (2 * n - 1); i++) TreeMat1[i] = new int[4];
  TreeMat2 = new int*[(2 * n2 - 1)];
  for(int i = 0; i < (2 * n2 - 1); i++) TreeMat2[i] = new int[4];

  int N = n, N2 = n2;
  for(int i = 0; i < numOfTrees; i++){
    if((i + 1) % 100 == 0)
      cout << "Iteration: " << i + 1 << endl;
    tree1 = new TreeNode;
    tree2 = new TreeNode;
    n = 0; n2 = 0; num = 1; num2 = 1; h = 0;
    readNewick(in, tree1, num, n);
    //  DFS3(tree1);
    readNewick(in2, tree2, num2, n2);
    assignLeafLevel(tree1, h);
    assignNum(tree1, h, n);
    h = 0;
    assignLeafLevel(tree2, h);
    assignNum(tree2, h, n2);
    TreeMatrixfun(TreeMat1, tree1, 2 * n - 1, BrLenV1);
    TreeMatrixfun(TreeMat2, tree2, 2 * n2 - 1, BrLenV2);
    for(int ii = 0; ii < (2 * n - 1); ii++)
      for(int j = 0; j < (2*n - 1); j++)
	Pairs[ii][j] = 0;
    for(int ii = 0; ii < N; ii++){
      for(int j = ii + 1; j < N2; j++){
	pairs[0] = ii + 1; pairs[1] = j + 1;
	Pairs[getMRCA(TreeMat1, n, 2, pairs, BrLenV1) - 1][getMRCA(TreeMat2, n2, 2, pairs, BrLenV2) - 1]++;
      }
    }
    deleteTree(tree1);
    deleteTree(tree2);
    /*    for(int ii = 0; ii < (2*N - 1); ii++){
      for(int j = 0; j < (2*N2 - 1); j++){
	cout << Pairs[ii][j] << " ";
      }
      cout << endl;
    }
    cout << endl;
    */
    for(int ii = 0; ii < (2*N - 1); ii++){
      for(int j = 0; j < (2*N2 - 1); j++){
	if(max < Pairs[ii][j]) max = Pairs[ii][j];
	if(Pairs[ii][j] > 1)
	  if(min > Pairs[ii][j]) min = Pairs[ii][j];
      }
    }
    Max += max;
    Min += min;
  }

  cout << "The maximum number sampled over all 10,000 runs: " << max << endl << "The average of maximum numbers sampled among 10,000 runs is: " << ((double) Max / (double)numOfTrees) << endl;
  cout << "The minimum number > 1 sampled over all 10,000 runs: " << min <<  endl <<  "The average of minimum numbers > 1 sampled among 10,000 runs is: "  << ((double) Min / (double)numOfTrees) << endl;

  return 0;
}
